LiquidMenu.h File Reference
`#include <stdint.h>`
`#include <stdio.h>`
`#include <stdlib.h>`
`#include "LiquidMenu_config.h"`
`#include "LiquidMenu_debug.h"`

Go to the source code of this file.

## Classes

class | LiquidLine
| Represents the individual lines printed on the display. More...
class | LiquidScreen
| Represents a screen shown on the display. More...
class | LiquidMenu
| Represents a collection of screens forming a menu. More...
class | LiquidSystem
| Represents a collection of menus forming a menu system. More...

## Typedefs

typedef bool(* | boolFnPtr) ()
typedef int8_t(* | int8tFnPtr) ()
typedef uint8_t(* | uint8tFnPtr) ()
typedef int16_t(* | int16tFnPtr) ()
typedef uint16_t(* | uint16tFnPtr) ()
typedef int32_t(* | int32tFnPtr) ()
typedef uint32_t(* | uint32tFnPtr) ()
typedef float(* | floatFnPtr) ()
typedef double(* | doubleFnPtr) ()
typedef char(* | charFnPtr) ()
typedef char *(* | charPtrFnPtr) ()
typedef const char *(* | constcharPtrFnPtr) ()

## Enumerations

enum

DataType : uint8_t {
NOT_USED = 0, BOOL = 1, BOOLEAN = 1, INT8_T = 8,
UINT8_T = 9, INT16_T = 16, UINT16_T = 17, INT32_T = 32,
UINT32_T = 33, FLOAT = 50, DOUBLE = 50, CHAR = 60,
CHAR_PTR = 61, CONST_CHAR_PTR = 62, PROG_CONST_CHAR_PTR = 65, GLYPH = 70,
BOOL_GETTER = 201, BOOLEAN_GETTER = 201, INT8_T_GETTER = 208, UINT8_T_GETTER = 209,
BYTE_GETTER = 209, INT16_T_GETTER = 216, UINT16_T_GETTER = 217, INT32_T_GETTER = 232,
UINT32_T_GETTER = 233, FLOAT_GETTER = 240, DOUBLE_GETTER = 240, CHAR_GETTER = 250,
CHAR_PTR_GETTER = 251, CONST_CHAR_PTR_GETTER = 252
}

| Data type enum. More...
enum | Position : uint8_t { RIGHT = 1, NORMAL = 1, LEFT = 2, CUSTOM = 3 }
| Position enum. More...

## Functions

void | print_me (uintptr_t address)
| Prints the number passed to it in a specific way. More...
recognizeType overloaded function
DataType | recognizeType (bool variable)
DataType | recognizeType (char variable)
DataType | recognizeType (char *variable)
DataType | recognizeType (const char *variable)
DataType | recognizeType (int8_t variable)
DataType | recognizeType (uint8_t variable)
DataType | recognizeType (int16_t variable)
DataType | recognizeType (uint16_t variable)
DataType | recognizeType (int32_t variable)
DataType | recognizeType (uint32_t variable)
DataType | recognizeType (float variable)
DataType | recognizeType (double variable)
DataType | recognizeType (boolFnPtr variable)
DataType | recognizeType (int8tFnPtr variable)
DataType | recognizeType (uint8tFnPtr variable)
DataType | recognizeType (int16tFnPtr variable)
DataType | recognizeType (uint16tFnPtr variable)
DataType | recognizeType (int32tFnPtr variable)
DataType | recognizeType (uint32tFnPtr varible)
DataType | recognizeType (floatFnPtr variable)
DataType | recognizeType (doubleFnPtr variable)
DataType | recognizeType (charFnPtr variable)
DataType | recognizeType (charPtrFnPtr variable)
DataType | recognizeType (constcharPtrFnPtr variable)

## Variables

const char | LIQUIDMENU_VERSION [] = "1.5"
| The version of the library. More...

## Detailed Description

Include file for LiquidMenu library.

Author
  Vasil Kalchev

Date
  2016

Version
  1.5.0

Copyright
  The MIT License

Todo:

  : Change/Remove variables/screens/menus maybe

  : screen wide glyphs

  : dynamic memory

  : variadic templates

## Enumeration Type Documentation

## DataType

enum DataType : uint8_t

strong

Data type enum.

Used to store the data type of `void*` so that they can be cast back later.

## Position

enum Position : uint8_t

strong

Position enum.

## Function Documentation

## print_me()

void print_me | ( | uintptr_t | address | ) |

Prints the number passed to it in a specific way.

Used for convenience when printing the class's address for indentification.

Parameters

  address | - number to be printed

## recognizeType() [1/24]

DataType recognizeType | ( | bool | variable | ) |

Used to recognize the data type of a variable received in a template function.

See also
  DataType

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [2/24]

DataType recognizeType | ( | char | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [3/24]

DataType recognizeType | ( | char * | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [4/24]

DataType recognizeType | ( | const char * | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [5/24]

DataType recognizeType | ( | int8_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [6/24]

DataType recognizeType | ( | uint8_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [7/24]

DataType recognizeType | ( | int16_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [8/24]

DataType recognizeType | ( | uint16_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [9/24]

DataType recognizeType | ( | int32_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [10/24]

DataType recognizeType | ( | uint32_t | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [11/24]

DataType recognizeType | ( | float | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [12/24]

DataType recognizeType | ( | double | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [13/24]

DataType recognizeType | ( | boolFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [14/24]

DataType recognizeType | ( | int8tFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [15/24]

DataType recognizeType | ( | uint8tFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [16/24]

DataType recognizeType | ( | int16tFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [17/24]

DataType recognizeType | ( | uint16tFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [18/24]

DataType recognizeType | ( | int32tFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [19/24]

DataType recognizeType | ( | uint32tFnPtr | varible | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [20/24]

DataType recognizeType | ( | floatFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [21/24]

DataType recognizeType | ( | doubleFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [22/24]

DataType recognizeType | ( | charFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [23/24]

DataType recognizeType | ( | charPtrFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## recognizeType() [24/24]

DataType recognizeType | ( | constcharPtrFnPtr | variable | ) |

Parameters

  variable | - variable to be checked

Returns
  the data type in `DataType` enum format

## Variable Documentation

## LIQUIDMENU_VERSION

const char LIQUIDMENU_VERSION[] = "1.5"

The version of the library.